%bcond_with                bootstrap

%define section            free

Name:           java-cup
Version:        11a
Release:        24
Epoch:          1
Summary:        LALR Parser Generator in Java
License:        BSD-style
URL:            http://www2.cs.tum.edu/projects/cup/
# https://www2.in.tum.de/WebSVN/dl.php?repname=CUP&path=/develop/&rev=0&isdir=1
Source0:        develop.tar.bz2
Source1:        java-cup.script
Source2:        java-cup-generated-files.tar.bz2
Patch0:         java-cup-javadoc.patch
Patch1:         java-cup-no-classpath-in-manifest.patch
Patch2:         java-cup-no-cup-no-jflex.patch
Patch3:         java-cup-classpath.patch
# Missing symbolFactory initialization in lr_parser, causes sinjdoc to crash
Patch4:         java-cup-lr_parser-constructor.patch
BuildRequires:  ant
%if %without bootstrap
BuildRequires:  java-cup
BuildRequires:  jflex
%endif
BuildRequires:  java-rpmbuild
Group:          Development/Java
Buildarch:      noarch
Obsoletes:      java_cup < 1:11a
Provides:       java_cup = %{epoch}:%{version}-%{release}

%description
java-cup is a LALR Parser Generator in Java.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Documentation for %{name}
Group:          Development/Java

%description manual
Documentation for %{name}.

%prep
%setup -q -n develop
%patch0 -p1
%patch1 -p1
%if %with bootstrap
%setup -q -T -D -a 2 -n develop
%patch2 -p1
%else
find . -name '*.jar' | %{_bindir}/xargs rm
%patch3 -p1
%endif
%patch4 -p1
perl -pi -e 's/1\.2/1\.4/g' build.xml
mkdir -p classes dist

%build
%if %with bootstrap
export CLASSPATH=
%else
export CLASSPATH=$(build-classpath java-cup jflex)
%endif
export OPT_JAR_LIST=
%ant
%ant javadoc

%install

# jar
mkdir -p %{buildroot}%{_javadir}
install -m 644 dist/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-%{version}-runtime.jar %{buildroot}%{_javadir}/%{name}-runtime-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)
# compatibility symlinks
(cd %{buildroot}%{_javadir} && ln -s %{name}.jar java_cup.jar && ln -s %{name}-runtime.jar java_cup-runtime.jar)

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -a dist/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && ln -s %{name}-%{version} %{name})

mkdir -p %{buildroot}%{_bindir}
install -m 755 %{SOURCE1} %{buildroot}%{_bindir}/java-cup

%files
%defattr(0644,root,root,0755)
%doc changelog.txt
%attr(0755,root,root) %{_bindir}/java-cup
%{_javadir}/*

%files manual
%defattr(0644,root,root,0755)
%doc manual.html

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog

* Fri Jul 03 2015 Denis Silakov <denis.silakov@rosalab.ru> 1:11a-24
- (115ae28) Rebuild with java8


